#include "LSMRegex.h"
#include "LSRegex.h"

bool LSRegexType::GetMember(LSOBJECTDATA ObjectData, PCHAR Member, int argc, char *argv[], LSOBJECT &Dest)
{
#define pRegex ((LSRegex *)ObjectData.Ptr)
	if (!ObjectData.Ptr)
		return false;
	PLSTYPEMEMBER pMember=LSRegexType::FindMember(Member);
	if (!pMember)
		return false;
	switch((LSRegexMembers)pMember->ID)
	{
	case Pattern:
		if (Dest.CharPtr=pRegex->Pattern)
		{
			Dest.Type=pStringType;
			return true;
		}
		return false;
	case Substitution:
		if (Dest.CharPtr=pRegex->Substitution)
		{
			Dest.Type=pStringType;
			return true;
		}
		return false;
	case Substitute:
		if (!argc)
			return false;
		{
			string str=argv[0];
			pRegex->PerformSubstitution(str);
			Dest.Ptr=pLSInterface->GetTempBuffer(str.length()+1,(void*)str.c_str());
			Dest.Type=pStringType;
		}
		return true;
	case Count:
		if (!argc || !pRegex->pPattern)
			return false;
		Dest.Int=pRegex->pPattern->count(argv[0]);
		Dest.Type=pIntType;
		return true;
	case MatchResults:
		if (!pRegex->pMatch)
			return false;
		Dest.Int=pRegex->pMatch->cbackrefs();
		Dest.Type=pIntType;
		return true;
	case MatchResult:
		if (!argc || !pRegex->pMatch)
			return false;
		{
			unsigned long N=atoi(argv[0])-1;
			if (N<pRegex->pMatch->cbackrefs())
			{
				match_results::backref_type br =pRegex->pMatch->backref(N);
				if (!br.matched)
					return false;
				string str2(br.str());
				Dest.Ptr=pLSInterface->GetTempBuffer(str2.length()+1,(void*)str2.c_str());
//				printf("%s",Dest.CharPtr);
				Dest.Type=pStringType;
			}
		}
		return true;
	case SplitResults:
		if (!pRegex->pSplit)
			return false;
		Dest.Int=pRegex->pSplit->strings().size();
		Dest.Type=pIntType;
		return true;
	case SplitResult:
		if (!argc || !pRegex->pSplit)
			return false;
		{
			unsigned long N=atoi(argv[0])-1;
			if (N>=pRegex->pSplit->strings().size())
				return false;
			string str=pRegex->pSplit->strings()[N];
			Dest.Ptr=pLSInterface->GetTempBuffer(str.length()+1,(void*)str.c_str());
			Dest.Type=pStringType;
		}
		return true;
	}
	return false;
#undef pRegex
}
bool LSRegexType::GetMethod(LSOBJECTDATA &ObjectData, char *Method, int argc, char *argv[])
{
#define pRegex ((LSRegex*)ObjectData.Ptr)
	if (!ObjectData.Ptr)
		return false;
	PLSTYPEMETHOD pMethod=LSRegexType::FindMethod(Method);
	if (!pMethod)
		return false;

	switch((LSRegexMethods)pMethod->ID)
	{
	case SetPattern:
		pRegex->SetPattern(argc,argv,NOCASE);
		return true;
	case SetPatternCS:
		pRegex->SetPattern(argc,argv);
		return true;
	case SetSubstitution:
		if (!argc)
			pRegex->SetSubstitution(0);
		else
			pRegex->SetSubstitution(argv[0]);
		return true;
	case Match:
		if (!argc)
			return false;
		pRegex->Match(argv[0]);
		return true;
	case Split:
		if (!argc)
			return false;
		pRegex->Split(argv[0]);
		return true;
	}
	return false;
#undef pRegex
}
